"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createErrorHandler = void 0;
const ErrorMapperBuilder_1 = require("./ErrorMapperBuilder");
function createErrorHandler(errorMapper) {
    const finalErrorMapper = errorMapper instanceof ErrorMapperBuilder_1.ErrorMapperBuilder ? errorMapper.get() : errorMapper;
    return (err, req, res, next) => {
        const errorOutput = finalErrorMapper(err);
        res.status(errorOutput.statusCode);
        if (errorOutput.headers) {
            for (const [headerName, headerValue] of Object.entries(errorOutput.headers)) {
                res.header(headerName, headerValue);
            }
        }
        res.json(errorOutput.payload);
    };
}
exports.createErrorHandler = createErrorHandler;
